//**********************
// K
//
// (C)Copyright 2009 All rights reserved by Y.Onodera
// http://einst.hp.infoseek.co.jp
//**********************
#if defined(__dsPIC30F__)
#include <p30fxxxx.h>
#elif defined(__dsPIC33F__)
#include <p33Fxxxx.h>
#elif defined(__PIC24H__)
#include <p24Hxxxx.h>
#elif defined(__PIC24F__)
#include <p24Fxxxx.h>
#endif

#include "test.h"

#include <stdio.h>
#include "K.h"
#include "Wait.h"
#include "LCD.h"
#include "RS232C.h"
#include "MSG.h"


int K_error;


// 00 status = BE 3E B0 00
unsigned char CNT[]={0x04,0x04,0x08,0x02,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x02,0x01,0x01,0x01,
					0x02,0x01,0x01,0x01,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x01,0x01,0x01,0x02,
					0x04,0x02,0x02,0x02,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x01,0x01,0x01,0x01,
					0x01,0x02,0x02,0x01,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x02,0x02,0x02,0x02,
					0x04,0x04,0x02,0x02,0x02,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x02,0x02,0x00,
					0x00,0x01,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};

// 1startbit(0) + LSB ... MSB + 1stopbit(1)
void Init5bps(unsigned char a){

	int i;

	K_TX_PORT=1;
	WaitNms(200);

	// Start bit=0
	K_TX_PORT=0;
	WaitNms(200);
	for(i=0;i<8;i++){
		if( (a & 0x01) == 0){
			K_TX_PORT=0;
		}else{
			K_TX_PORT=1;
		}
		a>>=1;
		WaitNms(200);
	}
	// Stop bit=1
	K_TX_PORT=1;
	WaitNms(250);

}


unsigned char Init5bpst(){

	int i;
	unsigned char a;
	a=0;

	while(K_RX_PORT==1);
	// Start bit=0
	WaitNms(300);
	for(i=0;i<8;i++){
		a>>=1;
		if( K_RX_PORT == 1){
			a = a | 0x80;;
		}
		WaitNms(200);
	}
	// Stop bit=1
	WaitNms(200);
	WaitNms(100);
	return a;

}


void Print()
{

	unsigned char b[2];
	int i;

	for(i=0;i<buffers;i++){
		sprintf((char *)b,"%02X", buf[i]);
		PutDatLCD(b[0]);
		PutDatLCD(b[1]);
	}
	buffers=0;

}


void Get9141()
{

	if(K_error==0){
#ifdef TEST
		buffers++;
#else
		buf[buffers++]=GetcCOM1();
#endif
	}

}


void Put9141(unsigned char a)
{

	if(K_error==0){
		PutcCOM1(a);
		Get9141();
		if(a==buf[buffers-1]){
			WaitNms(10);	// 5-20ms
		}else{
#ifdef TEST
			buf[buffers-1]=a;
#else
			K_error=1;
#endif
		}
	}

}


void Request9141(unsigned char a)
{

	unsigned int sum;
	unsigned char b;

	Put9141(0x68);
	Put9141(0x6a);
	Put9141(0xf1);
	Put9141(0x01);
	Put9141(a);
	sum = 0x68 + 0x6a + 0xf1 + 0x01 + a;
	b = sum & 0xFF;
	Put9141(b);
	buffers=0;

}


void Recieve9141(unsigned char a)
{

	unsigned char i;

	for(i=0;i<5;i++){
		Get9141();
	}
	for(i=0;i<=CNT[a];i++){
		Get9141();
	}
}


void InitK()
{

	int i;

	WaitNms(300);

	// 5bps, 0x33
	Init5bps(0x33);

	OpenCOM1();

	// response 0x55 0x08 0x08
	LocateLCD(0,1);
	for(i=0;i<3;i++){
		Get9141();
	}
	Print();
	WaitNms(25);
	Put9141(0xf7);
	// response for 0xCC
	Get9141();
	Print();
	WaitNms(55);

}


void InitKt()
{

	int i;

	// 5bps, 0x33
	i=Init5bpst();

	OpenCOM1();

	// response 0x55 0x08 0x08
	WaitNms(10);
	Put9141(0x55);
	WaitNms(10);
	Put9141(0x08);
	WaitNms(10);
	Put9141(0x08);

	// 0xf7
	Get9141();
	WaitNms(10);
	Put9141(0xcc);
	Print();

}


void PrintPID()
{

	char msg[10];

	LocateLCD(0,0);
	sprintf(msg,"ISO K %02X", buf[4]);
	PutsLCD(msg);
	LocateLCD(0,1);

	GetMSG(msg,4);
	PutsLCD(msg);
	buffers=0;

}


void Print9141()
{

	if(K_error==0){
		PrintPID();
		WaitNs(3);
	}else{
		CloseCOM1();
		WaitNs(10);
		InitK();
		K_error=0;
	}

}


void Request9141DTC()
{

	unsigned int sum;
	unsigned char b;

	Put9141(0x68);
	Put9141(0x6a);
	Put9141(0xf1);
	Put9141(0x03);
	sum = 0x68 + 0x6a + 0xf1 + 0x03;
	b = sum & 0xFF;
	Put9141(b);
	buffers=0;

}


void Recieve9141DTC()
{

	unsigned char i;

	for(i=0;i<5;i++){
		Get9141();
	}
//	for(i=0;i<=6;i++){
	for(i=0;i<=2;i++){
		Get9141();
	}
}


void PrintKDTC(unsigned char j)
{

	char msg[10];

	LocateLCD(0,0);
	sprintf(msg,"K   DTC%d",j);
	PutsLCD(msg);
	LocateLCD(0,1);

	GetDTC(msg,j*2+2);
	PutsLCD(msg);
	buffers=0;

}


void Print9141DTC(unsigned char j)
{

	if(K_error==0){
		PrintKDTC(j);
		WaitNs(3);
	}else{
		CloseCOM1();
		WaitNs(10);
		InitK();
		K_error=0;
	}

}


void Request9141CLR()
{

	char msg[10];
	unsigned int sum;
	unsigned char b;

	Put9141(0x68);
	Put9141(0x6a);
	Put9141(0xf1);
	Put9141(0x04);
	sum = 0x68 + 0x6a + 0xf1 + 0x04;
	b = sum & 0xFF;
	Put9141(b);
	buffers=0;

	LocateLCD(0,1);
	sprintf(msg,"cleared ");
	PutsLCD(msg);
	LocateLCD(0,1);
	WaitNs(3);

}


void SendK(){

	char msg[10];
	unsigned int sum;
	unsigned char a,b,i;

	sum=0;
	a=buf[4];

	PutMSG(4);
	buffers=0;
	Put9141(0x48);
	Put9141(0x6b);
	buffers=0;
	Put9141(0x0e);
	Put9141(0x41);
	Put9141(a);
	sum = 0x48 + 0x6b + 0x0e + 0x41 + a;

	for(i=0;i<CNT[a];i++){
		Put9141(buf[3+i]);
		sum += buf[3+i];
	}

	b = sum & 0xFF;
	Put9141(b);
	buffers=0;

	LocateLCD(0,1);
	sprintf(msg,"K     %02X", a);
	PutsLCD(msg);

}

